Index: tests/Makefile.am
===================================================================
--- tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,74 @@
+
+#
+# tests directory for libabac
+#
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+PYTHON_ENV = PYTHONPATH=$(abs_top_builddir)/swig/python:$(abs_top_builddir)/swig/python/.libs:$(abs_top_builddir)/tests
+PERL_ENV = PERLLIB=$(abs_top_builddir)/swig/perl:$(abs_top_builddir)/swig/perl/.libs
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+
+MY_SH_ENV = env $(CREDDY_ENV) $(PROVER_ENV) 
+MY_PY_ENV = env $(PROVER_ENV) $(PYTHON_ENV)
+MY_PL_ENV = env $(PERL_ENV)
+
+DIRECTORY = example_scripts python_tests scaling_tests \
+          creddy_tests creddy_prover_tests attr_tests
+
+.PHONY: clean clean-local check_sh_env check_py_env tests
+all: check_pl_env check_sh_env check_py_env tests
+
+tests:
+	@touch result
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  make -s runcheck | tee -a $$here/result; \
+	  cd $$here; \
+	done
+
+check_sh_env:
+	@rc=`$(MY_SH_ENV) ./test_util.sh`; \
+	if [ $$? -eq 0 ]; then \
+	  echo "sh_env, okay"; \
+	else \
+	  echo "sh_env, not okay"; \
+	  echo "perhap you did not configure&build libabac's c api??"; \
+	fi
+
+check_py_env:
+	@rc=`$(MY_PY_ENV) ./test_util.py`; \
+	if [ $$? -eq 0 ]; then \
+	  echo "py_env, okay"; \
+	else \
+	  echo "py_env, not okay"; \
+	  echo "perhap you did not configure&build libabac's swig/python api??"; \
+	fi
+
+check_pl_env:
+	@rc=`$(MY_PL_ENV) ./test_util.pl`; \
+	if [ $$? -eq 0 ]; then \
+	  echo "pl_env, okay"; \
+	else \
+	  echo "pl_env, not okay"; \
+	  echo "perhap you did not configure&build libabac's swig/perl api??"; \
+	fi
+	
+	
+clean:
+	for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  make clean; \
+	  cd $$here; \
+	done
+	rm -rf result error
+	rm -rf test_util.pyc
+
+clean-local:
+	rm -rf result error
+	rm -rf test_util.pyc
Index: tests/README
===================================================================
--- tests/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,26 @@
+
+This directory serves as a regression testing and performance testing
+platform for libabac.  It contains many actual valid RT0
+examples in C/python/perl. It also contain examples of Creddy in
+action.
+
+creddy_prover_tests : various RT examples using Creddy and abac_prover,
+                      a C implemenation of an ABAC prover
+python_tests: same RT examples as in creddy_prover_tests but in python scripts
+              using libabac ABAC
+example_scripts: small examples scripts in perl/python/C, wiki contains examples
+              used on libabac's wiki page
+scaling_tests: performance testing
+attr_tests: testing different types of attribute xml format
+creddy_tests : a comphrensive testing of creddy
+
+
+To run,
+
+   make tests
+
+if running on BSD,
+
+   make -i tests
+
+
Index: tests/attr_tests/Makefile.am
===================================================================
--- tests/attr_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/attr_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,37 @@
+#
+# attr_tests
+#
+
+.PHONY: runcheck clean-local setup
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV)
+
+all:runcheck
+
+runcheck: setup.sh
+	@make clean
+	@echo 'running libabac ATTRS testing...' | tee result
+	@touch error
+	@$(MY_ENV) ./setup.sh 
+	@($(MY_ENV) ./show.sh |tee -a result |grep BAD >> ../error; cd .)
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;); \
+	    fi); \
+	  else echo "   PASSED"; \
+	fi
+
+clean:
+	@rm -rf *.xml *.pem error result
+
+clean-local:
+	@rm -rf *.xml *.pem error result
+
+
Index: tests/attr_tests/README
===================================================================
--- tests/attr_tests/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/attr_tests/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -3,8 +3,10 @@
 
 privilege_attr.xml,  a valid self-signed priviledge GENI attribute credential 
-                     with multiple attribute rules 
+                     with multiple(6) attribute rules 
 
 abac_attr.xml,  a valid self-signed abac attribute credential with a single 
                 attribute rule
 
+not_ss.xml, a valid none self-signed abac attribute credential with a single
+            attribute rule
 
Index: tests/attr_tests/not_ss.xml_save
===================================================================
--- tests/attr_tests/not_ss.xml_save	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/attr_tests/not_ss.xml_save	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,67 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<signed-credential>
+    <credential xml:id="ref0">
+	<type>abac</type>
+	<version>1.0</version>
+	<expires>2014-05-20T17:39:55Z</expires>
+	<rt0>0a778934b93d546406d195d18e4f208af11ea84a.test_attr&lt;-633aadf1753647ba60f28b7310f5a56cd32ab7e2</rt0>
+    </credential>
+    <signatures>
+	<Signature xmlns="http://www.w3.org/2000/09/xmldsig#">
+	    <SignedInfo>
+		<CanonicalizationMethod Algorithm="http://www.w3.org/2001/10/xml-exc-c14n#"/>
+		<SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#rsa-sha1"/>
+		<Reference URI="#ref0">
+		    <Transforms>
+			<Transform Algorithm="http://www.w3.org/2000/09/xmldsig#enveloped-signature"/>
+		    </Transforms>
+		    <DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/>
+		    <DigestValue>PZhnlEVuQz0AEHrBFzEcuefhWB8=</DigestValue>
+		</Reference>
+	    </SignedInfo>
+	    <SignatureValue>wYIkXgDSnzeTVu/Cc2C2W5bib6w0SVzZcKSabls47Qr6rJMdNUKrO3YOV8fcHrbT
+9wsCrEq2v2d8kuueuzSjzXvZrgBBfXrMe83Z427F0todl5/IhQTgXtKyhYsKZEvU
+5C50FVKSs/spKCqcO95TYtzEZEAu6yCJV/Oa59TYt/4=</SignatureValue>
+	    <KeyInfo>
+	      <KeyValue>
+<RSAKeyValue>
+<Modulus>
+9+Qkp1j1gFuVflZuISN005C4uAuYAyJ/ntVD4tWTnTl2KEuCRlzbmpBMk5DXqxYW
+ouuXTjffiQwfMOYufvj9p/mvEPGKlJz5/Fd3dY1fbQ2cg/RckWX4ikC36Z4bmSya
+Kws7APsjDu6luAH2ggFXXoHIUej0jm7KpDTRI3kW+NU=
+</Modulus>
+<Exponent>
+AQAB
+</Exponent>
+</RSAKeyValue>
+</KeyValue>
+		<X509Data>
+		    
+		    
+		    
+		<X509Certificate>MIIC+DCCAmECAg2pMA0GCSqGSIb3DQEBBAUAMIHRMQswCQYDVQQGEwJVUzETMBEG
+A1UECBMKQ2FsaWZvcm5pYTEXMBUGA1UEBxMOTWFyaW5hIGRlbCBSZXkxJzAlBgNV
+BAoTHkRFVEVSIE5ldHdvcmsgU2VjdXJpdHkgVGVzdGJlZDEeMBwGA1UECxMVQ2Vy
+dGlmaWNhdGUgQXV0aG9yaXR5MR4wHAYDVQQDExVib3NzLmlzaS5kZXRlcmxhYi5u
+ZXQxKzApBgkqhkiG9w0BCQEWHHRlc3RiZWQtb3BzQGlzaS5kZXRlcmxhYi5uZXQw
+HhcNMTAxMTA1MjIzNTEyWhcNMTMwODAxMjIzNTEyWjCBtTELMAkGA1UEBhMCVVMx
+EzARBgNVBAgTCkNhbGlmb3JuaWExJzAlBgNVBAoTHkRFVEVSIE5ldHdvcmsgU2Vj
+dXJpdHkgVGVzdGJlZDESMBAGA1UECxMJc3NseG1scnBjMS0wKwYDVQQDEyQ3MGY0
+ZGI1Yy1jN2Y1LTExZGMtYTIwNC0wMDA0MjNjMjhlNzYxJTAjBgkqhkiG9w0BCQEW
+FmZhYmVyQGlzaS5kZXRlcmxhYi5uZXQwgZ8wDQYJKoZIhvcNAQEBBQADgY0AMIGJ
+AoGBAPfkJKdY9YBblX5WbiEjdNOQuLgLmAMif57VQ+LVk505dihLgkZc25qQTJOQ
+16sWFqLrl04334kMHzDmLn74/af5rxDxipSc+fxXd3WNX20NnIP0XJFl+IpAt+me
+G5ksmisLOwD7Iw7upbgB9oIBV16ByFHo9I5uyqQ00SN5FvjVAgMBAAEwDQYJKoZI
+hvcNAQEEBQADgYEAjGn3aZtem7Me+uGpPw6xEs8pwd3EtJ9yLofr2EMOkUKYNTHL
+fVV8cqybBCYF+RH8UYZPk3oIYH0XCfa1dzEeOcEBmYqlhcDgM8Y0Wpfh5t590ScI
+h7nN7kzGIN0wpUG6sASNqQdXA8YxwpPE/XjLrE0QKT69bU2rZnBGqSYcpzY=</X509Certificate>
+<X509SubjectName>emailAddress=faber@isi.deterlab.net,CN=70f4db5c-c7f5-11dc-a204-000423c28e76,OU=sslxmlrpc,O=DETER Network Security Testbed,ST=California,C=US</X509SubjectName>
+<X509IssuerSerial>
+<X509IssuerName>emailAddress=testbed-ops@isi.deterlab.net,CN=boss.isi.deterlab.net,OU=Certificate Authority,O=DETER Network Security Testbed,L=Marina del Rey,ST=California,C=US</X509IssuerName>
+<X509SerialNumber>3497</X509SerialNumber>
+</X509IssuerSerial>
+</X509Data>
+	    </KeyInfo>
+	</Signature>
+    </signatures>
+</signed-credential>
Index: tests/attr_tests/setup.sh
===================================================================
--- tests/attr_tests/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/attr_tests/setup.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+cp abac_attr.xml_save abac_attr.xml
+cp privilege_attr.xml_save privilege_attr.xml
+cp not_ss.xml_save not_ss.xml
+
Index: tests/attr_tests/show.sh
===================================================================
--- tests/attr_tests/show.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/attr_tests/show.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,10 +1,21 @@
 #!/bin/sh
+#show.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --roles --cert $1
+#expect 1 rule
+runCTest "attr_tests/show.sh" "test1" \
+"$eloc/creddy --roles --cert abac_attr.xml" \
+0 "show a V0 abac attribute-1 rule" "<-" 1
+
+#expect 6 rule
+runCTest "attr_tests/show.sh" "test2" \
+"$eloc/creddy --roles --cert privilege_attr.xml" \
+0 "show a V0 GENI privilege attribute-6 rules" "<-" 6
+
+#expect 1 rule
+runCTest "attr_tests/show.sh" "test3" \
+"$eloc/creddy --roles --cert not_ss.xml" \
+0 "show a V0 abac not self signed attribute-1 rule" "<-" 1
+
+
Index: tests/creddy_prover_tests/Makefile.am
===================================================================
--- tests/creddy_prover_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/creddy_prover_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,48 @@
+#
+# creddy_prover_tests
+#
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV)
+
+DIRECTORY=acme_rockets_intersection_rt0 acme_rockets_rt0 \
+          experiment_create_rt0 ice_cream_rt0
+
+.PHONY : clean clean-local runcheck
+all: runcheck
+
+runcheck :
+	@echo 'running libabac CREDDY_PROVER testing...' | tee result
+	@touch error
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  printf "\n ==> RUN on %s\n" "$$i" >> $$here/result ; \
+	  $(MY_ENV) ./README 1>/dev/null 2>&1; \
+	  $(MY_ENV) ./run_query |tee -a $$here/result |grep BAD >> $$here/error; \
+	  cd $$here; \
+	done
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;) \
+	    fi) \
+	  else echo "   PASSED"; \
+	fi
+
+
+clean :
+	@for i in $(DIRECTORY); do \
+	  here=`pwd`; \
+	  cd $$i; \
+	  rm -rf *.pem *.xml; \
+	  cd $$here; \
+	done
+	@rm -rf result error
+
+clean-local: 
+	@rm -rf result error
Index: tests/creddy_prover_tests/acme_rockets_intersection_rt0/README
===================================================================
--- tests/creddy_prover_tests/acme_rockets_intersection_rt0/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/acme_rockets_intersection_rt0/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -34,13 +34,15 @@
 rm -rf *.xml *.pem
 
-creddy --generate --cn Acme
+. ${TESTDIR}/test_util.sh
 
-creddy --generate --cn WarnerBros
+$eloc/creddy --generate --cn Acme
 
-creddy --generate --cn Coyote
+$eloc/creddy --generate --cn WarnerBros
 
-creddy --generate --cn Batman
+$eloc/creddy --generate --cn Coyote
 
-creddy --attribute \
+$eloc/creddy --generate --cn Batman
+
+$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role buy_rockets \
        --subject-cert Acme_ID.pem --subject-role preferred_customer \
@@ -48,15 +50,15 @@
        --out Acme_buy_rockets__Acme_preferred_customer_and_WarnerBros_character_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role preferred_customer \
        --subject-cert Coyote_ID.pem \
        --out Acme_preferred_customer__Coyote_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role preferred_customer \
        --subject-cert Batman_ID.pem \
        --out Acme_preferred_customer__Batman_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer WarnerBros_ID.pem --key WarnerBros_private.pem --role character \
        --subject-cert Coyote_ID.pem \
Index: tests/creddy_prover_tests/acme_rockets_intersection_rt0/run_query
===================================================================
--- tests/creddy_prover_tests/acme_rockets_intersection_rt0/run_query	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/acme_rockets_intersection_rt0/run_query	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,17 +1,10 @@
 #!/bin/sh
-# acme_rockets_intersection
 
-pwd=`pwd`
+. ${TESTDIR}/test_util.sh
+keyloc=`pwd`
 
-eloc=`which abac_prover | sed 's/\/abac_prover//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: abac_prover is not in the search path!!!"
-  exit 1
-fi
-keyloc=$pwd
-
-acme=`creddy --keyid --cert $keyloc/Acme_ID.pem`
-batman=`creddy --keyid --cert $keyloc/Batman_ID.pem`
-coyote=`creddy --keyid --cert $keyloc/Coyote_ID.pem`
+acme=`$eloc/creddy --keyid --cert $keyloc/Acme_ID.pem`
+batman=`$eloc/creddy --keyid --cert $keyloc/Batman_ID.pem`
+coyote=`$eloc/creddy --keyid --cert $keyloc/Coyote_ID.pem`
 
 buy_rockets="$acme.buy_rockets"
@@ -21,23 +14,26 @@
 bad_buy_rockets2="99$acme.buy_rockets"
 
-echo "  "
 echo "===good============ Acme.buy_rockets <- Coyote"
-$eloc/abac_prover  --keystore $keyloc \
-              --role "$buy_rockets" --principal "$coyote_prin"
+runTest creddy_prover_test/acme_rockets_intersection_rt0 test1 \
+  "$ploc/abac_prover --keystore $keyloc --role $buy_rockets --principal $coyote_prin" \
+  0 \
+  "simple rt0 query"
 
-echo "  "
 echo "===bad============ Acme.bad_buy_rockets <- Coyote"
-$eloc/abac_prover  --keystore $keyloc \
-              --role "$bad_buy_rockets" --principal "$coyote_prin"
+runTest creddy_prover_test/acme_rockets_intersection_rt0 test2 \
+  "$ploc/abac_prover  --keystore $keyloc --role $bad_buy_rockets --principal $coyote_prin" \
+  1 \
+  "expected failure, query fail with unfound role but should return with partial proof"
 
-echo "  "
 echo "===bad============ 99Acme.buy_rockets <- Coyote"
-$eloc/abac_prover  --keystore $keyloc \
-              --role "$bad_buy_rockets2" --principal "$coyote_prin"
+runTest creddy_prover_test/acme_rockets_intersection_rt0 test3 \
+  "$ploc/abac_prover  --keystore $keyloc --role $bad_buy_rockets2 --principal $coyote_prin" \
+  1 \
+  "expected failure, query fail with none existing issuer principal"
 
-echo "  "
 echo "===bad=============== Acme.buy_rockets <- Batman"
-$eloc/abac_prover  --keystore $keyloc \
-              --role "$buy_rockets" --principal "$batman_prin"
+runTest creddy_prover_test/acme_rockets_intersection_rt0 test4 \
+  "$ploc/abac_prover  --keystore $keyloc --role $buy_rockets --principal $batman_prin" \
+  1 \
+  "expected failure, query fail with none existing target principal"
 
-
Index: tests/creddy_prover_tests/acme_rockets_rt0/README
===================================================================
--- tests/creddy_prover_tests/acme_rockets_rt0/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/acme_rockets_rt0/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -20,11 +20,5 @@
 
 rm -rf *.pem *.xml
-
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
 $eloc/creddy --generate --cn Acme
Index: tests/creddy_prover_tests/acme_rockets_rt0/run_query
===================================================================
--- tests/creddy_prover_tests/acme_rockets_rt0/run_query	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/acme_rockets_rt0/run_query	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,15 +1,9 @@
 #!/bin/sh
 
-pwd=`pwd`
-eloc=`which abac_prover | sed 's/\/abac_prover//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: abac_prover is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
+keyloc=`pwd`
 
-keyloc=$pwd
-
-acme=`creddy --keyid --cert $keyloc/Acme_ID.pem`
-coyote=`creddy --keyid --cert $keyloc/Coyote_ID.pem`
+acme=`$eloc/creddy --keyid --cert $keyloc/Acme_ID.pem`
+coyote=`$eloc/creddy --keyid --cert $keyloc/Coyote_ID.pem`
 
 preferred_customer="$acme.preferred_customer"
@@ -21,28 +15,31 @@
 #[keyid:Acme].role:preferred_customer <-?- [keyid:Coyote]
 #isMember(pCoyote, role(pAcme,preferred_customer), C).
-echo "  "
 echo "===good============ Acme.preferred_customer <- Coyote"
-$eloc/abac_prover  --keystore $keyloc \
-      --role "$preferred_customer" --principal "$coyote_prin"
+runTest creddy_prover_test/acme_rockets_rt0 test1 \
+  "$ploc/abac_prover  --keystore $keyloc --role $preferred_customer --principal $coyote_prin" \
+  0 \
+  "simple rt0 query with 1 matched rule"
 
 #[keyid:Acme].role:buy_rockets <-?- [keyid:Coyote]
 #isMember(pCoyote, role(pAcme,buy_rockets), C).
-echo "  "
 echo "===good=============== Acme.buy_rockets <- Coyote"
-$eloc/abac_prover  --keystore $keyloc \
-        --role "$buy_rockets" --principal "$coyote_prin"
+runTest creddy_prover_test/acme_rockets_rt0 test2 \
+  "$ploc/abac_prover  --keystore $keyloc --role $buy_rockets --principal $coyote_prin" \
+  0 \
+  "rt0 query that returns 2 rules"
 
 ## this is not suppose to work
 #[keyid:Acme].role:buy_rockets <-?- [keyid:Acme].role:preferred_customer
-echo "  "
 echo "===bad=============== Acme.buy_rockets <- Acme.preferred_customer"
-$eloc/abac_prover  --keystore $keyloc \
-        --role "$buy_rockets" --principal "$preferred_customer"
+runTest creddy_prover_test/acme_rockets_rt0 test3 \
+  "$ploc/abac_prover  --keystore $keyloc --role $buy_rockets --principal $preferred_customer" \
+  0 \
+  "this query is not suppose to work but alas did not block it, a.r1 <- b.r2"
 
 #[keyid:Coyote].role:friend <-?- [keyid:Acme]
 #isMember(pAcme, role(pCoyote,friend), C).
-echo "  "
 echo "===bad=============== Coyote.friend <- Acme"
-$eloc/abac_prover  --keystore $keyloc \
-        --role "$friend" --principal "$acme_prin"
-
+runTest creddy_prover_test/acme_rockets_rt0 test4 \
+  "$ploc/abac_prover  --keystore $keyloc --role $friend --principal $acme_prin" \
+  1 \
+  "the assumption is not supported by rules "
Index: tests/creddy_prover_tests/experiment_create_rt0/README
===================================================================
--- tests/creddy_prover_tests/experiment_create_rt0/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/experiment_create_rt0/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -28,33 +28,35 @@
 rm -rf *.pem *.xml
 
-creddy --generate --cn Acme
+. ${TESTDIR}/test_util.sh
 
-creddy --generate --cn Globotron
+$eloc/creddy --generate --cn Acme
 
-creddy --generate --cn Alice
+$eloc/creddy --generate --cn Globotron
 
-creddy --generate --cn Bob
+$eloc/creddy --generate --cn Alice
 
-creddy --attribute \
+$eloc/creddy --generate --cn Bob
+
+$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role experiment_create \
        --subject-cert Acme_ID.pem --subject-role partner.experiment_create \
        --out Acme_experiment_create__Acme_partner_experiment_create_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role partner \
        --subject-cert Globotron_ID.pem \
        --out Acme_partner__Globotron_attr.xml 
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Globotron_ID.pem --key Globotron_private.pem --role experiment_create \
        --subject-cert Globotron_ID.pem --subject-role admin.power_user \
        --out Globotron_experiment_create__Globotron_admin_power_user_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Globotron_ID.pem --key Globotron_private.pem --role admin \
        --subject-cert Alice_ID.pem \
        --out Globotron_admin__Alice_attr.xml
 
-creddy --attribute \
+$eloc/creddy --attribute \
        --issuer Alice_ID.pem --key Alice_private.pem --role power_user \
        --subject-cert Bob_ID.pem \
Index: tests/creddy_prover_tests/experiment_create_rt0/run_query
===================================================================
--- tests/creddy_prover_tests/experiment_create_rt0/run_query	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/experiment_create_rt0/run_query	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,16 +1,11 @@
 #!/bin/sh
 
-pwd=`pwd`
-eloc=`which abac_prover | sed 's/\/abac_prover//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: abac_prover is not in the search path!!!"
-  exit 1
-fi
-keyloc=$pwd
+. ${TESTDIR}/test_util.sh
+keyloc=`pwd`
 
-acme=`creddy --keyid --cert $keyloc/Acme_ID.pem`
-alice=`creddy --keyid --cert $keyloc/Alice_ID.pem`
-bob=`creddy --keyid --cert $keyloc/Bob_ID.pem`
-globotron=`creddy --keyid --cert $keyloc/Globotron_ID.pem`
+acme=`$eloc/creddy --keyid --cert $keyloc/Acme_ID.pem`
+alice=`$eloc/creddy --keyid --cert $keyloc/Alice_ID.pem`
+bob=`$eloc/creddy --keyid --cert $keyloc/Bob_ID.pem`
+globotron=`$eloc/creddy --keyid --cert $keyloc/Globotron_ID.pem`
 
 glob_admin="$globotron.admin"
@@ -19,18 +14,24 @@
 experiment_create="$acme.experiment_create"
 
-echo " "
 echo "===good=============== Globotron.admin <- Alice"
-$eloc/abac_prover  --keystore $keyloc \
-             --role "$glob_admin" --principal "$alice_prin"
-
-echo " "
-echo "===bad=============== Globotron.admin <- Bob"
-$eloc/abac_prover  --keystore $keyloc \
-             --role "$glob_admin" --principal "$bob_prin"
-
-echo " "
-echo "===good=============== Acme.experiment_create <- Bob"
-$eloc/abac_prover  --keystore $keyloc \
-             --role "$experiment_create" --principal "$bob_prin"
+runTest creddy_prover_test/experiment_create_rt0 test1 \
+  "$ploc/abac_prover  --keystore $keyloc --role $glob_admin --principal $alice_prin" \
+  0 \
+  "simple query"
 
 
+echo "===bad=============== Globotron.admin <- Bob"
+runTest creddy_prover_test/experiment_create_rt0 test2 \
+  "$ploc/abac_prover  --keystore $keyloc --role $glob_admin --principal $bob_prin" \
+  1 \
+  "no rule support this, should get a partial proof"
+
+echo "===good=============== Acme.experiment_create <- Bob"
+runTest creddy_prover_test/experiment_create_rt0 test3 \
+  "$ploc/abac_prover  --keystore $keyloc  --role $experiment_create --principal $bob_prin" \
+  0 \
+  "mutilple rules intersection proof"
+
+
+
+
Index: tests/creddy_prover_tests/ice_cream_rt0/README
===================================================================
--- tests/creddy_prover_tests/ice_cream_rt0/README	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/ice_cream_rt0/README	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -15,10 +15,5 @@
 rm -rf *.pem *.xml
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
 $eloc/creddy --generate --cn IceCream
Index: tests/creddy_prover_tests/ice_cream_rt0/run_query
===================================================================
--- tests/creddy_prover_tests/ice_cream_rt0/run_query	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_prover_tests/ice_cream_rt0/run_query	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,35 +1,31 @@
 #!/bin/sh
 
-pwd=`pwd`
-eloc=`which abac_prover | sed 's/\/abac_prover//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: abac_prover is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
+keyloc=`pwd`
 
-keyloc=$pwd
-
-ice=`creddy --keyid --cert $keyloc/IceCream_ID.pem`
-chocolate_prin=`creddy --keyid --cert $keyloc/Chocolate_ID.pem`
+ice=`$eloc/creddy --keyid --cert $keyloc/IceCream_ID.pem`
+chocolate_prin=`$eloc/creddy --keyid --cert $keyloc/Chocolate_ID.pem`
 
 delicious="$ice.delicious"
 
-echo "  "
 echo "===good============ IceCream.delicious <- Chocolate"
-$eloc/abac_prover  --keystore $keyloc \
-      --role "$delicious" --principal "$chocolate_prin"
+runTest creddy_prover_test/ice_cream_rt0 test1 \
+  "$ploc/abac_prover  --keystore $keyloc --role $delicious --principal $chocolate_prin" \
+  0 \
+  "very basic simple call"
+
+rm -rf IceCream*.pem
+echo "===good(no issuer)============ IceCream.delicious <- Chocolate"
+runTest creddy_prover_test/ice_cream_rt0 test2 \
+  "$ploc/abac_prover  --keystore $keyloc --role $delicious --principal $chocolate_prin" \
+  0 \
+  "basic simple call without the issuer's principal id in local keystore"
 
 
-rm -rf IceCream*.pem
-echo "  "
-echo "===good(no issuer)============ IceCream.delicious <- Chocolate"
-$eloc/abac_prover  --keystore $keyloc \
-      --role "$delicious" --principal "$chocolate_prin"
+rm -rf Chocolate*.pem
+echo "===good(no issuer & no principal)============ IceCream.delicious <- Chocolate"
+runTest creddy_prover_test/ice_cream_rt0 test1 \
+  "$ploc/abac_prover  --keystore $keyloc --role $delicious --principal $chocolate_prin" \
+  0 \
+  "basic simple call without the issuer's principal id nor principal id in local keystore"
 
-rm -rf Chocolate*.pem
-echo "  "
-echo "===good(no issuer & no principal)============ IceCream.delicious <- Chocolate"
-$eloc/abac_prover  --keystore $keyloc \
-      --role "$delicious" --principal "$chocolate_prin"
-
-
Index: tests/creddy_tests/Makefile.am
===================================================================
--- tests/creddy_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
+++ tests/creddy_tests/Makefile.am	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -0,0 +1,40 @@
+#
+# creddy_tests
+#
+
+.PHONY: runcheck clean-local setup
+
+INCLUDES = -I$(abs_top_srcdir)/libabac
+LDADD = $(abs_top_builddir)/libabac/libabac.la
+CREDDY_ENV = CREDDY_LOCATION=$(abs_top_builddir)/creddy
+PROVER_ENV = PROVER_LOCATION=$(abs_top_builddir)/libabac
+TEST_ENV = TESTDIR=$(abs_top_builddir)/tests
+MY_ENV = env $(CREDDY_ENV) $(PROVER_ENV) $(TEST_ENV)
+
+SCRIPT=verify roles attribute keyid generate display attribute_rule 
+
+runcheck: setup.sh
+	@echo 'running libabac CREDDY testing...' | tee result
+	@make clean
+	@$(MY_ENV) ./setup.sh
+	@touch error
+	@for i in $(SCRIPT); do \
+	  echo "---running $$i script"  >> result; \
+	  $(MY_ENV) ./$$i.sh | tee -a result |grep BAD >> error; cd .; \
+	done
+	@if test -f error ; \
+	  then \
+	    (if test `cat error | wc -l ` -eq 0 ; \
+	      then echo "   PASSED"; \
+	      else (echo "   ERROR!!!"; cat error;) \
+	    fi) \
+	  else echo "   PASSED"; \
+	fi
+
+clean:
+	@rm -rf *.xml *.pem error result
+
+clean-local:
+	@rm -rf *.xml *.pem error result
+
+
Index: tests/creddy_tests/attribute.sh
===================================================================
--- tests/creddy_tests/attribute.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/attribute.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,30 +1,33 @@
 #!/bin/sh
+#attribute.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --attribute \
+runTest "creddy_tests/attribute.sh" "test1"  \
+"$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role roleOne \
        --subject-cert Acme_ID.pem --subject-role simple_subject_role \
-       --out Acme_roleOne__Acme_simple_subject_role_attr.xml
+       --out Acme_roleOne__Acme_simple_subject_role_attr.xml" \
+0  "simple role attribute creation with same issuer"
 
-$eloc/creddy --attribute \
+runTest "creddy_tests/attribute.sh" "test2"  \
+"$eloc/creddy --attribute \
        --issuer Acme_ID.pem --role roleTwo \
        --subject-cert Acme_ID.pem --subject-role simple_subject_role \
-       --out Acme_roleTwo__Acme_simple_subject_role_attr.xml
+       --out Acme_roleTwo__Acme_simple_subject_role_attr.xml" \
+1  "simple role attribute creation without privkey key"
 
-$eloc/creddy --attribute \
+runTest "creddy_tests/attribute.sh" "test3"  \
+"$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Acme_private.pem --role roleThree \
        --subject-cert Coyote_ID.pem --subject-role simple_subject_role \
-       --out Acme_roleThree__Coyote_simple_subject_role_attr.xml
+       --out Acme_roleThree__Coyote_simple_subject_role_attr.xml" \
+0  "simple role attribute creation with differ issuer certs"
 
-$eloc/creddy --attribute \
+runTest "creddy_tests/attribute.sh" "test4"  \
+"$eloc/creddy --attribute \
        --issuer Acme_ID.pem --key Coyote_private.pem --role roleFour \
        --subject-cert Coyote_ID.pem --subject-role simple_subject_role \
-       --out Acme_roleFour__Coyote_simple_subject_role_attr.xml
+       --out Acme_roleFour__Coyote_simple_subject_role_attr.xml" \
+1  "simple role attribute creation with wrong privkey key"
 
-
Index: tests/creddy_tests/attribute_rule.sh
===================================================================
--- tests/creddy_tests/attribute_rule.sh	(revision f520b1ed74a0c375b8bf912e662b7be6bed67640)
+++ tests/creddy_tests/attribute_rule.sh	(revision 6cd69a0d7919d36d4cc937ae13ce7f09034097d5)
@@ -1,26 +1,21 @@
 #!/bin/sh
-
 #attribute_rule.sh
 
-pwd=`pwd`
-eloc=`which creddy | sed 's/\/creddy//'`
-if [ "$eloc" = "" ]; then
-  echo "ERROR: creddy is not in the search path!!!"
-  exit 1
-fi
+. ${TESTDIR}/test_util.sh
 
-$eloc/creddy --generate --cn Bigbird 1>/dev/null 2>& 1
-$eloc/creddy --generate --cn Coyote 1>/dev/null 2>& 1
-
-bigbird=`creddy --keyid --cert Bigbird_ID.pem`
-coyote=`creddy --keyid --cert Coyote_ID.pem`
+bigbird=`$eloc/creddy --keyid --cert Bigbird_ID.pem`
+coyote=`$eloc/creddy --keyid --cert Coyote_ID.pem`
 
 rule="$coyote.sneaky_friend<-$bigbird"
 
-$eloc/creddy --attribute \
+runTest "creddy_tests/attribute_rule.sh" "test1"  \
+"$eloc/creddy --attribute \
        --issuer Coyote_ID.pem --key Coyote_private.pem \
        --attrrule "$rule" \
-       --out Coyote_sneakyFriend__Bigbird_attr.xml
+       --out Coyote_sneakyFriend__Bigbird_attr.xml"  \
+0  "trying making attribute using attrrule option"
 
-$eloc/creddy --roles --cert Coyote_sneakyFriend__Bigbird_attr.xml
+runTest "creddy_tests/attribute_rule.sh" "test2"  \
+"$eloc/creddy --roles --cert Coyote_sneakyFriend__Bigbird_attr.xml"  \
+0  "double check on the attribute made with atttrrule option"
 
